"""
show_broadcast.py defines functions showing broadcast device info.
"""

from Tkinter import *
import thread
import time


class show_broadcast (Tk):
    """
    GUI class for broadcast devices.
    """

    def __init__(self, player, index=0, speed=10, master=None):
        """
	create a separate window using Tkinter widgets.
	create a thread for periodic sensory data update.
	"""
	# save the configuration
	self.__player = player
	self.__device_index = index
	self.__update_speed = speed
	# create a gui
	Tk.__init__(self)
	self.title('Broadcast : ' + str(self.__device_index))
	self.__message = Text(self, width=80, height=25)
	# set layouts of widgets
	self.__message.pack()
	# start an update thread
	self.__update_flag = 1
	thread.start_new_thread(self.__update_thread, ())


    def configure(self, index=0, speed=10):
        """
	change the configuration on the fly.
	"""
	self.__device_index = index
	self.__update_speed = speed


    def close(self):
        """
	close the window, and kill it self.
	"""
	self.__update_flag = 0


    def __update_thread(self):
        """
	update sensory information.
	"""
	print '<start a broadcast update thread>'
	while self.__update_flag:
	    try:
		# update a message window
		self.__message.insert(END, self.__player.broadcast[self.__device_index][0])
		# slow down
		time.sleep(1.0 / self.__update_speed)
	    except KeyError:
	        print '<broadcast:%d is not enabled yet>' % self.__device_index
		self.close()
	    except AttributeError:
		print '<invalid player object>'
	        self.close()
	    except TclError:
		self.close()
	print '<the broadcast update thread finishes>'

